<?php
class Learner {
    public $boc;
    public $id = NULL;
    public $type = NULL;
    public $course;
	public $email;
    public $firstname;
	public $lastname;
	public $status;
	public $user_id;
	private $groups = array();
    // This does not belong to profile, added here to avoid profile loading
    private $blogurl = "";
	
	public function __construct($id = NULL) {
		$this->boc = new BackOfficeService();
		if ($id) {
			$this->id = $id; 
		}
    }
    
    public function add() {
        return $this->boc->addLearner($this->dataXML());
	}

    public function enroll() {
        return $this->boc->enrollLearner($this->dataXML());
	}

    public function activate() {
        return $this->boc->activateLearner($this->dataXML());
    }
     
    public function remove() {   
        return $this->boc->removeLearner($this->idXML());
    }
  
    public function load($loader = false) {      
        if (!$loader) $loader = $this->boc->loadLearner($this->idXML());
		if ($loader) {
			$this->type = 'learner';
            $this->id = $loader->id[0][0];
            $this->course = $loader->course[0][0];
            $this->email = $loader->email[0][0];
            $this->firstname = $loader->firstname[0][0];
            $this->lastname = $loader->lastname[0][0];
            $this->status = $loader->status[0][0];
			/*if (isset($loader->groups[0]['coursegroup'])) {
				foreach ($loader->groups[0]['coursegroup'] as $single) {
					$group = new Coursegroup();
					$group->load((object) $single);
					$this->groups[$group->id] = $group;
				}
            }*/
            if (isset($loader->blogurl[0][0])) $this->blogurl = $loader->blogurl[0][0];
			$this->user_id = $loader->{'user-id'}[0][0];
        }
    }
    
    public function getURL() {
        return $this->getPortfolioURL();
	}

	public function getPortfolioURL() {
		return WWW_ROOT."course/participants/{$this->course}/portfolio/{$this->id}";
	}

	public function getProfileURL() {
		return WWW_ROOT."profile/view/{$this->user_id}";
	}

    public function getBlogURL() {
        return $this->blogurl;
    }
    
    public function getType() {
        return $this->type;
    }
    
    public function canEdit() {
        if (is_admin()) {
            return 1;
        }
        return 0;
    }
    
    public function getCourse() {
        return $this->course;    
    }
    
    public function getEmail() {
        return $this->email;    
    }
    
    public function getFirstname() {
        return $this->firstname;    
    }
    
    public function getLastname() {
        return $this->lastname;    
    }
    
    public function getFullname() {
        return $this->firstname." ".$this->lastname;    
    }
    
    public function getStatus() {
        return $this->status;    
    }
    
    public function isEnrolled() {
        if ($this->getStatus() > 0) {
            return true;
        }    
        return false;
    }

	public function isActive() {
		if ($this->getStatus() == 5) {
			return true;
		}
		return false;
	}
    
    function idXML() {
        $data = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>";
        $data .= "<learner>";
        $data .= "<id>".$this->id."</id>";
		$data .= "</learner>";
		return $data;
    }
    
    function dataXML() {
        $data = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>";
        $data .= "<learner>";
        $data .= "<id>".$this->id."</id>";
        $data .= "<courseId>".$this->course."</courseId>";
		$data .= "<email>".$this->email."</email>";
		$data .= "<firstname><![CDATA[".$this->firstname."]]></firstname>";
		$data .= "<lastname><![CDATA[".$this->lastname."]]></lastname>";
		$data .= "<status>".$this->status."</status>";
		$data .= "</learner>";
		return $data;
    }

	function hasGroups() {
		if (sizeof($this->groups)>0) return true;
		return false;
	}

	function getGroups() {
		return $this->groups;
	}
}
?>
